unit AdjustDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls;

type
  TAdjustForm = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    ClearButton: TButton;
    procedure SpinEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ClearButtonClick(Sender: TObject);
  private
    function GetHandicap: Integer;
    procedure SetHandicap(Value: Integer);
    function GetStep: Integer;
    procedure SetStep(Value: Integer);
  public
    property Handicap: Integer read GetHandicap write SetHandicap;
    property Step: Integer read GetStep write SetStep;
  end;

var
  AdjustForm: TAdjustForm;

implementation

{$R *.DFM}

function TAdjustForm.GetHandicap: Integer;
begin
  Result := SpinEdit1.Value;
end;

procedure TAdjustForm.SetHandicap(Value: Integer);
begin
  SpinEdit1.Value := Value;
end;

procedure TAdjustForm.SpinEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then ModalResult := mrOK;
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

procedure TAdjustForm.ClearButtonClick(Sender: TObject);
begin
  SpinEdit1.Value := 0;
end;

function TAdjustForm.GetStep: Integer;
begin
  Result := SpinEdit1.Increment;
end;

procedure TAdjustForm.SetStep(Value: Integer);
begin
  SpinEdit1.Increment := Value;
end;

end.
