unit PrefsDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Math, TornResizer, Spin, ComCtrls;

type
  TPrefsForm = class(TForm)
    GamesToView: TRadioGroup;
    OKButton: TButton;
    CancelButton: TButton;
    HelpButton: TButton;
    SoloHandicaps: TRadioGroup;
    PageControl1: TPageControl;
    System: TTabSheet;
    SystemType: TRadioGroup;
    GroupBox1: TGroupBox;
    StatusServerLabel: TLabel;
    DBServerLabel: TLabel;
    StatusServerIP: TEdit;
    DBServerIP: TEdit;
    Configuration: TTabSheet;
    GroupPlayersBy: TRadioGroup;
    DefaultHandicapStyle: TRadioGroup;
    SortTeamsBy: TRadioGroup;
    NexusHelios: TTabSheet;
    CommitGroupBox: TGroupBox;
    AutoUpdateScoreboard: TCheckBox;
    AutoUpdateTeams: TCheckBox;
    NexusScores: TRadioGroup;
    NexusDeniesGroupBox: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    NexusOneShotDenyEnemy: TSpinEdit;
    NexusTwoShotDenyEnemy: TSpinEdit;
    NexusOneShotDenyFriend: TSpinEdit;
    NexusTwoShotDenyFriend: TSpinEdit;
    NexusStunDenyEnemy: TSpinEdit;
    NexusStunDenyFriend: TSpinEdit;
    Dimensions: TTabSheet;
    SpinHigh: TSpinEdit;
    Label1: TLabel;
    SpinWide: TSpinEdit;
    Label2: TLabel;
    SpinPlayers: TSpinEdit;
    Label3: TLabel;
    TornResizer1: TTornResizer;
    Laserforce: TTabSheet;
    Label5: TLabel;
    Label11: TLabel;
    AliasAutocomplete: TSpinEdit;
    Label12: TLabel;
    Label13: TLabel;
    GamesLimit: TSpinEdit;
    Label14: TLabel;
    ScoreboardStyle: TRadioGroup;
    procedure GroupPlayersByClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure SpinChange(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure TornResizer1DblClick(Sender: TObject);
    procedure SystemTypeClick(Sender: TObject);
  private
    FSekritsVisible: Boolean;
  public
    constructor CreatePrefsForm(Grids: TStringList; Owner: TComponent);

    property SekritsVisible: Boolean read FSekritsVisible;
  end;

var
    PrefsForm: TPrefsForm;
    GridRet: TStringList;
implementation

//uses ResizeDialog;

{$R *.DFM}

// Call the inherited Create, and set up league data in the treeview.
constructor TPrefsForm.CreatePrefsForm(Grids: TStringList; Owner: TComponent);
begin
    PrefsForm := Create(Owner);  // call the inherited Create

    GridRet := Grids;  // remember the Grids variable, so we will later be able to return values in it

    SpinHigh.Value    := StrToInt(Grids[0]);
    SpinWide.Value    := StrToInt(Grids[1]);
    SpinPlayers.Value := StrToInt(Grids[2]);

    SpinChange(Self);

    TornResizer1.Height := Screen.Height div 7;
    TornResizer1.Width  := Screen.Width  div 7;

//    GridSizeGroupBox.Height := 118 + TornResizer1.Height;
//    ClientWidth  := Min(800, 444 + TornResizer1.Width);

    SystemTypeClick(nil);
end;

procedure TPrefsForm.GroupPlayersByClick(Sender: TObject);
begin
    SortTeamsBy.Enabled := GroupPlayersBy.ItemIndex = 1;
end;

procedure TPrefsForm.OKButtonClick(Sender: TObject);
begin
    GridRet.CommaText := IntToStr(SpinHigh.Value) + ',' +
                         IntToStr(SpinWide.Value) + ',' +
                         IntToStr(SpinPlayers.Value);
end;

procedure TPrefsForm.SpinChange(Sender: TObject);
begin
    TornResizer1.GridHigh   := SpinHigh.Value;
    TornResizer1.GridWide   := SpinWide.Value;
    TornResizer1.GridPlayers:= SpinPlayers.Value;
end;

procedure TPrefsForm.HelpButtonClick(Sender: TObject);
begin
    Application.HelpCommand(HELP_CONTEXT, HelpContext);
end;

procedure TPrefsForm.TornResizer1DblClick(Sender: TObject);
begin
    FSekritsVisible := True;
end;

procedure TPrefsForm.SystemTypeClick(Sender: TObject);
const SYSTEMNAME: array [-1..4] of string = ('database', 'Acacia', 'Nexus', 'Nexus', 'Laserforce', 'Demo');
var i: Integer;
begin
    StatusServerIP.Enabled := SystemType.ItemIndex = 0;
    StatusServerLabel.Enabled := StatusServerIP.Enabled;
    DBServerIP.Enabled := SystemType.ItemIndex <> 4;
    DBServerLabel.Enabled := DBServerIP.Enabled;

    NexusScores.Enabled := SystemType.ItemIndex in [1, 2];
    NexusDeniesGroupBox.Enabled := SystemType.ItemIndex in [1, 2];
    for i := 0 to NexusDeniesGroupBox.ControlCount - 1 do
        NexusDeniesGroupBox.Controls[i].Enabled := SystemType.ItemIndex in [1, 2];

    GamesToView.Items[0] := 'View games from ' + SYSTEMNAME[SystemType.ItemIndex] + '''s stats table (i.e. today''s games)';
end;

end.
